<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfV_SDD_PendentesERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfV_SDD_PendentesERP
 * @subpackage Arrays
 */
class ArrayOfV_SDD_PendentesERP extends AbstractStructArrayBase
{
    /**
     * The V_SDD_PendentesERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\V_SDD_PendentesERP[]
     */
    public $V_SDD_PendentesERP;
    /**
     * Constructor method for ArrayOfV_SDD_PendentesERP
     * @uses ArrayOfV_SDD_PendentesERP::setV_SDD_PendentesERP()
     * @param \StructType\V_SDD_PendentesERP[] $v_SDD_PendentesERP
     */
    public function __construct(array $v_SDD_PendentesERP = array())
    {
        $this
            ->setV_SDD_PendentesERP($v_SDD_PendentesERP);
    }
    /**
     * Get V_SDD_PendentesERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\V_SDD_PendentesERP[]|null
     */
    public function getV_SDD_PendentesERP()
    {
        return isset($this->V_SDD_PendentesERP) ? $this->V_SDD_PendentesERP : null;
    }
    /**
     * Set V_SDD_PendentesERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\V_SDD_PendentesERP[] $v_SDD_PendentesERP
     * @return \ArrayType\ArrayOfV_SDD_PendentesERP
     */
    public function setV_SDD_PendentesERP(array $v_SDD_PendentesERP = array())
    {
        foreach ($v_SDD_PendentesERP as $arrayOfV_SDD_PendentesERPV_SDD_PendentesERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfV_SDD_PendentesERPV_SDD_PendentesERPItem instanceof \StructType\V_SDD_PendentesERP) {
                throw new \InvalidArgumentException(sprintf('The V_SDD_PendentesERP property can only contain items of \StructType\V_SDD_PendentesERP, "%s" given', is_object($arrayOfV_SDD_PendentesERPV_SDD_PendentesERPItem) ? get_class($arrayOfV_SDD_PendentesERPV_SDD_PendentesERPItem) : gettype($arrayOfV_SDD_PendentesERPV_SDD_PendentesERPItem)), __LINE__);
            }
        }
        if (is_null($v_SDD_PendentesERP) || (is_array($v_SDD_PendentesERP) && empty($v_SDD_PendentesERP))) {
            unset($this->V_SDD_PendentesERP);
        } else {
            $this->V_SDD_PendentesERP = $v_SDD_PendentesERP;
        }
        return $this;
    }
    /**
     * Add item to V_SDD_PendentesERP value
     * @throws \InvalidArgumentException
     * @param \StructType\V_SDD_PendentesERP $item
     * @return \ArrayType\ArrayOfV_SDD_PendentesERP
     */
    public function addToV_SDD_PendentesERP(\StructType\V_SDD_PendentesERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\V_SDD_PendentesERP) {
            throw new \InvalidArgumentException(sprintf('The V_SDD_PendentesERP property can only contain items of \StructType\V_SDD_PendentesERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->V_SDD_PendentesERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\V_SDD_PendentesERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\V_SDD_PendentesERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\V_SDD_PendentesERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\V_SDD_PendentesERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\V_SDD_PendentesERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string V_SDD_PendentesERP
     */
    public function getAttributeName()
    {
        return 'V_SDD_PendentesERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfV_SDD_PendentesERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
